WordMakerParser Class Reference documentation

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
WordMakerParser Class Referencefinal

the main class to read a WordMaker file More...

`#include <WordMakerParser.hxx>`

Inheritance diagram for WordMakerParser:

## Public Member Functions
| WordMakerParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor More...
| ~WordMakerParser () final
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not) More...
void | parse (librevenge::RVNGTextInterface *documentInterface) final
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWTextParser
| ~MWAWTextParser () override
| destructor More...
virtual void | parse (librevenge::RVNGTextInterface *documentInterface)=0
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
virtual bool | checkHeader (MWAWHeader *header, bool strict=false)=0
| virtual function used to check if the document header is correct (or not) More...
int | version () const
| returns the works version More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWListenerPtr | getMainListener ()
| returns the main listener More...
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener More...
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener More...
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener More...
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...

## Protected Member Functions
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document More...
bool | createZones ()
| finds the different objects zones More...
void | newPage ()
| adds a new page More...
bool | sendZone (WordMakerParserInternal::Zone const &zone)
| try to send the content of a zone More...
bool | sendPicture (MWAWEntry const &entry)
| try to send a picture More...
bool | readFont (long len, MWAWFont &font)
| try to read a font and its beginning position More...
bool | readFontNames (long len)
| try to read the fonts names More...
bool | readParagraph (long len, MWAWParagraph &para, MWAWFont &font)
| try to read a paragraph (and its default font) More...
bool | readPicture (long len, MWAWEmbeddedObject &object, MWAWBox2f &bdbox, int &page)
| try to read a picture (and its size) More...
bool | readTabulations (long len, MWAWParagraph &para)
| try to read a list of tabulations More...
bool | readPrintInfo (long len)
| try to read the printer information More...
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWTextParser (MWAWParserStatePtr const &state)
| constructor using a state More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state More...
void | setVersion (int vers)
| sets the document's version More...
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener More...
void | resetGraphicListener ()
| resets the listener More...
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener More...
void | resetPresentationListener ()
| resets the listener More...
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener More...
void | resetSpreadsheetListener ()
| resets the listener More...
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener More...
void | resetTextListener ()
| resets the listener More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Protected Attributes
std::shared_ptr< WordMakerParserInternal::State > | m_state
| the state More...

## Friends
class | WordMakerParserInternal::SubDocument

## Detailed Description

the main class to read a WordMaker file

## Constructor & Destructor Documentation

## ◆ WordMakerParser()

WordMakerParser::WordMakerParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

## ◆ ~WordMakerParser()

WordMakerParser::~WordMakerParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkHeader()

bool WordMakerParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |
| finalvirtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse().

## ◆ createDocument()

void WordMakerParser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse().

## ◆ createZones()

bool WordMakerParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse().

## ◆ newPage()

void WordMakerParser::newPage | ( |  | ) |
| protected

adds a new page

Referenced by sendZone().

## ◆ parse()

void WordMakerParser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| finalvirtual

virtual function used to parse the input

Implements MWAWTextParser.

## ◆ readFont()

bool WordMakerParser::readFont | ( | long | len,
|  | MWAWFont & | font
| ) |  |
| protected

try to read a font and its beginning position

Referenced by readParagraph(), and sendZone().

## ◆ readFontNames()

bool WordMakerParser::readFontNames | ( | long | len | ) |
| protected

try to read the fonts names

Referenced by createZones().

## ◆ readParagraph()

bool WordMakerParser::readParagraph | ( | long | len,
|  | MWAWParagraph & | para,
|  | MWAWFont & | font
| ) |  |
| protected

try to read a paragraph (and its default font)

Referenced by sendZone().

## ◆ readPicture()

bool WordMakerParser::readPicture | ( | long | len,
|  | MWAWEmbeddedObject & | object,
|  | MWAWBox2f & | bdbox,
|  | int & | page
| ) |  |
| protected

try to read a picture (and its size)

Referenced by sendPicture().

## ◆ readPrintInfo()

bool WordMakerParser::readPrintInfo | ( | long | len | ) |
| protected

try to read the printer information

Referenced by createZones().

## ◆ readTabulations()

bool WordMakerParser::readTabulations | ( | long | len,
|  | MWAWParagraph & | para
| ) |  |
| protected

try to read a list of tabulations

Referenced by sendZone().

## ◆ sendPicture()

bool WordMakerParser::sendPicture | ( | MWAWEntry const & | entry | ) |
| protected

try to send a picture

Referenced by parse().

## ◆ sendZone()

bool WordMakerParser::sendZone | ( | WordMakerParserInternal::Zone const & | zone | ) |
| protected

try to send the content of a zone

Referenced by parse().

## Friends And Related Function Documentation

## ◆ WordMakerParserInternal::SubDocument

friend class WordMakerParserInternal::SubDocument
| friend

## Member Data Documentation

## ◆ m_state

std::shared_ptr<WordMakerParserInternal::State> WordMakerParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), createZones(), newPage(), parse(), sendZone(), and WordMakerParser().

The documentation for this class was generated from the following files:

- WordMakerParser.hxx
- WordMakerParser.cxx